#if defined _SYSTEM_VEHICLE
	#endinput
#endif
#define _SYSTEM_VEHICLE

// ------------------------------------
#define GetVehicleInfo(%0,%1)		g_vehicle_info[%0][%1]
#define GetVehicleName(%0)			GetVehicleInfo(GetVehicleData(%0, V_MODELID)-400, VI_NAME)

// ------------------------------------
#define GetVehicleData(%0,%1)		g_vehicle_data[%0][%1]
#define SetVehicleData(%0,%1,%2)	g_vehicle_data[%0][%1] = %2
#define ClearVehicleData(%0)		g_vehicle_data[%0] = g_vehicle_default_values
#define IsValidVehicleID(%0)		(1 <= %0 < MAX_VEHICLES)

// ------------------------------------
#define GetVehicleParamEx(%0,%1) g_vehicle_params[%0][%1]

// ------------------------------------
#define VEHICLE_ACTION_TYPE_NONE 	-1
#define VEHICLE_ACTION_ID_NONE 		-1

// ------------------------------------
#define VEHICLE_PARAM_ON	(1)
#define VEHICLE_PARAM_OFF	(0)

// ------------------------------------
native IsValidVehicle(vehicleid);

// ------------------------------------
enum E_VEHICLE_STRUCT
{
	V_MODELID,
	Float: V_SPAWN_X,
	Float: V_SPAWN_Y,
	Float: V_SPAWN_Z,
	Float: V_SPAWN_ANGLE,
	V_COLOR_1,
	V_COLOR_2,
	V_RESPAWN_DELAY,
	V_ADDSIREN,
	// -------------
	V_ACTION_TYPE,
	V_ACTION_ID,
	// -------------
	V_DRIVER_ID,
	// -------------
	V_LIMIT,
	V_ALARM,
	Float: V_FUEL,
	Float: V_MILEAGE,
	// -------------
	Text3D: V_LABEL,
	// -------------
	Float: V_HEALTH,
	V_LAST_LOAD_TIME,
	V_RENT, 			//   
	V_RENTP,
	V_OWRENT
};

// ------------------------------------
enum E_VEHICLE_PARAMS_STRUCT
{
	V_ENGINE, 	// 
	V_LIGHTS, 	// 
	V_ALARM,	// 
	V_LOCK, 	//  
	V_BONNET, 	// 
	V_BOOT, 	// 
	V_OBJECTIVE //    qa
};

// ------------------------------------
enum E_VEHICE_INFO_STRUCT
{
	VI_NAME[36],	// 
	VI_PRICE,		// . 
	VT_RENT_PRICE,	//  
	VI_TYPE,		// 
	Float: VI_SPEED            // 
};

// ------------------------------------
new g_vehicle_data[MAX_VEHICLES][E_VEHICLE_STRUCT];
new
	g_vehicle_default_values[E_VEHICLE_STRUCT] =
{
	0,
	0.0,
	0.0,
	0.0,
	0.0,
	0,
	0,
	0,
	0,
	VEHICLE_ACTION_TYPE_NONE,
	VEHICLE_ACTION_ID_NONE,
	INVALID_PLAYER_ID,
	false,
	false,
	40.0,
	0.0,
	Text3D:-1,
	1000.0,
	0,
	-1,
	0,
	0,
};
new g_vehicle_params[MAX_VEHICLES][E_VEHICLE_PARAMS_STRUCT];

new const
	g_vehicle_info[14789][E_VEHICE_INFO_STRUCT] =
{
	{"Porsche Cayenne",	17500000,		8500,	2},		// 400
	{" 2712",				125000,		500,	0},		// 401
	{"Mercedes-Benz E63 AMG",		10250000,		20000,	1},		// 402
	{" ", 			0, 			0,		0},		// 403
	{"Volvo 940",		412500	,		800,	2},		// 404
	{"Audi RS-6 Avant",	15000000,		8000,	1},		// 405
	{"", 	3000, 			20000,		0},		// 406
	{"", 			0,			0,		0},		// 407
	{"", 			0,			0,		0},		// 408
	{"Rolls-Royce Phantom",				32000000,	200000,	2},		// 409
	{"Mercedes-Benz C63S",	15000000,		7800,	0},		// 410
	{"MMC Lancer EVO",			1500000,		3800,	2},		// 411
	{"Mercedes-Benz W123",			575000,		600,	0},		// 412
	{"",				0,			4000,		0},		// 413
	{"", 			0,			0,		0},		// 414
	{"Lamborghini Aventador",				50000000,	15000,	2},		// 415
	{"", 				0,			0,		0},		// 416
	{"",			0,			15000,		0},		// 417
	{"", 		0,		6400,	0},		// 418
	{"Opel Astra GTC",			2050000,		    0,	    0},		// 419
	{"", 				0,			0,		0},		// 420
	{"Peugeot 406",		412500,		8000,	1},		// 421
	{"Jeep Grand Cherokee",			800000,		1000,	0},		// 422
	{"", 			0,			0,		0},		// 423
	{"",					0,		100,	0},		// 424
	{"", 				0,			0,		0},		// 425
	{"",			0,	38000,	2},		// 426
	{"", 			0,			0,		0},		// 427
	{"", 			0,			0,		0},		// 428
	{"Mercedes-Benz Maybach X222", 				32500000,	18000,	0},		// 429
	{"", 			0,			0,		0},		// 430
	{"", 			0,			0,		0},		// 431
	{"", 				0,			0,		0},		// 432
	{"-4320", 		3000,			0,		0},		// 433
	{"",			2900000,		    0,	    0},		// 434
	{"", 				0,			0,		0},		// 435
	{"Kia Stinger GT",	12000000,	16500,	1},		// 436
	{"", 				0,			0,		0},		// 437
	{"", 				0,			0,		0},		// 438
	{" 2101",			250000,		350,	0},		// 439
	{"", 				0,		0,		0},		// 440
	{"RCcar", 				0,			0,		0},		// 441
	{"", 				0,		3000,	0},		// 442
	{"", 			0,			0,		0},		// 443
	{"", 				0,			0,		0},		// 444
	{"Skoda Octavia RS",			850000,		2400,	0},		// 445
	{"Squalo", 				50000000,			0,		0},		// 446
	{" ", 		0,			0,		0},		// 447
	{"", 			0,			0,		0},		// 448
	{"", 			0,			0,		0},		// 449
	{"", 				0,			0,		0},		// 450
	{"Ferrari F12",	27500000,	22000,	2},		// 451
	{"Speeder", 			180000000,			0,		0},		// 452
	{"Reefer", 				0,			0,		0},		// 453
	{"TROPIC", 				230000000,			0,		0},		// 454
	{"", 			0,			0,		0},		// 455
	{" Next", 			0,			0,		0},		// 456
	{"", 			0,			0,		0},		// 457
	{"Audi A4",			2700000,		2400,	0},		// 458
	{"Mercedes-Benz Vito", 				650000,			0,		0},		// 459
	{" ", 		0,			0,		0},		// 460
	{"Honda CB 750",			750000,		700,	0},		// 461
	{"Scooter",			75000,		200,	0},		// 462
	{"Harley Chopper",				2300000,		1200,	1},		// 463
	{"RCplane", 			0,			0,		0},		// 464
	{"RCheli", 				0,			0,		0},		// 465
	{"BMW G30",			15000000,	28000,	2},		// 466
	{" 2107",				287500,		350,	0},		// 467
	{"MotoCross",				75000,		400,	0},		// 468
	{"Robinson R22", 			100000000,			0,		0},		// 469
	{"", 				3000,			0,		0},		// 470
	{"SNOWMOBILE",			68000,		1200,	1},		// 471
	{"", 				0,			0,		0},		// 472
	{"DINGHY",				1000000,			0,		0},		// 473
	{"",				0,		600,	0},		// 474
	{"BMW X5",	3200000,	14500,	1},		// 475
	{"Volkswagen Touareg", 		2000000,			0,		0},		// 476
	{"Mazda RX-7",			1100000,		9000,	1},		// 477
	{" 27151",			125000,		450,	0},		// 478
	{"Renault Logan",			1100000,		2400,	0},		// 479
	{"Audi R8",	22500000,	28000,	2},		// 480
	{"BMX",		15000,		100,	0},		// 481
	{" ", 			225000,		520000,	1},		// 482
	{" 3205", 			0,			0,		0},		// 483
	{"", 			0,			0,		0},		// 484
	{"", 			0,			0,		0},		// 485
	{"", 			0,			0,		0},		// 486
	{"Robinson R44", 				200000000,			8000,		0},		// 487
	{"News ", 			0,			0,		0},		// 488
	{"Toyota Land Cruiser 200",		17500000,	19000,	2},		// 489
	{"Range Rover Vogue", 	20000000,	59000,	2},		// 490
	{"Honda Civic",		2400000,		8000,	1},		// 491
	{" 2109",			475000,		1800,	0},		// 492
	{"Jetmax", 				150000000,			0,		0},		// 493
	{"Dodge Challenger", 			    10750000,	56000,	0},		// 494
	{"Ford Raptor", 7000000,	15000,	2},		// 495
	{"Opel Ascona",				325000,		700,	0},		// 496
	{" ", 			0,			0,		0},		// 497
	{"", 			0,			6000,		0},		// 498
	{" 53", 				0,			0,		0},		// 499
	{"UAZ Hunter",			180000,		400,	0},		// 500
	{"RCgobl", 				0,			0,		0}, 	// 501
	{"Rolls-Royce Wraith", 			33750000,	56000,	0}, 	// 502
	{"Nissan GT-R 35", 17000000,	56000,	2}, 	// 503
	{"Lamborghini Urus", 			11500000,			0,		0}, 	// 504
	{"Bentley Bentyaga",	30000000,	42000,	2},		// 505
	{"Porsche 911",		31000000,	29000,	1},		// 506
	{"BMW E34",			1300000,		2400,	0}, 	// 507
	{"Ford Raptor",			1200000,		1000,	0}, 	// 508
	{"'",	3000,		150,	0}, 	// 509
	{"BTBike",	12500,		300,	0}, 	// 510
	{"", 				0,			0,		0}, 	// 511
	{"", 			0,			0,		0}, 	// 512
	{"", 				0,			0,		0}, 	// 513
	{" 54115",			0,			0,		0}, 	// 514
	{"", 				0,			0,		0}, 	// 515
	{"Ford Focus 3",			2300000,		1800,	1}, 	// 516
	{" ",			0,		1500,	0}, 	// 517
	{"-762",			59300,		1000,	0}, 	// 518
	{"Shamal", 				0,			0,		0}, 	// 519
	{"", 		0,			0,		0}, 	// 520
	{"",		100000,		350,	0}, 	// 521
	{"Ducati Desmosed. RR",				5250000,		6000,	2}, 	// 522
	{"",			0,		    320,	0}, 	// 523
	{"", 			0,			0,		0}, 	// 524
	{"  ", 			0,			0,		0}, 	// 525
	{"Ford Sierra",			525000,		1600,	0}, 	// 526
	{"Volkswagen Golf",				437500,		    2400,	0}, 	// 527
	{" Patriot", 			0,			0,		0},		// 528
	{"",		0,		2500,	1},		// 529
	{"", 			0,			0,		0}, 	// 530
	{"", 			0,			0,		0}, 	// 531
	{"", 			0,			0,		0}, 	// 532
	{"Porsche Boxster",		9500000,	15000,	2}, 	// 533
	{"BMW E30",			1200000,		    4000,	1}, 	// 534
	{"Subaru Impreza WRX",			3000,		4000,	0}, 	// 535
	{"Volvo 240",				525000,		    3500,	1}, 	// 536
	{"", 				0,			0,		0}, 	// 537
	{"", 				0,			0,		0}, 	// 538
	{" ", 		0,			0,		0}, 	// 539
	{"Mercedes-Benz E55",			2000000,		1800,	0}, 	// 540
	{"Ferrari LaFerrari",		30000000,	42000,	2}, 	// 541
	{" 969",			200000,		1300,	0}, 	// 542
	{"Tesla Model S", 				15000000,	        48000,	0}, 	// 543
	{"", 			0,			0,		0}, 	// 544
	{"", 		0, 		    2000,	0}, 	// 545
	{" 2125 ",			225000,		600,	0}, 	// 546
	{"Audi 80",			375000,		600,	0}, 	// 547
	{" ", 			0, 			0,		0},		// 548
	{"",				75000,		35,		0},		// 549
	{" 2170",	450000,		1400,	0}, 	// 550
	{"BMW E39",			3000000,		110,	0}, 	// 551
	{" ", 		0,		    2100,	0}, 	// 552
	{"", 			0,			0,		0}, 	// 553
	{" Patriot", 			900000,			0,		0}, 	// 554
	{" 968",				62500,		50,		0}, 	// 555
	{"", 				0,			0,		0}, 	// 556
	{"", 				0,			80000,		0}, 	// 557
	{"BMW M4",				10000000,		    4500,	1}, 	// 558
	{"Toyota Supra",		3000000,	16000,	1}, 	// 559
	{"Subaru WRX STI",				2500000,	26500,	1}, 	// 560
	{" 2115",			210000,		600,	0},		// 561
	{"Nissan Skyline",		1800000,	25000,	2}, 	// 562
	{" ", 			0,			0,		0}, 	// 563
	{"RCtank", 				0,			0,		0}, 	// 564
	{" 2108",			362500,		1700,	0}, 	// 565
	{"Daewoo Lanos",			700000,		1000,	0}, 	// 566
	{" 2106",				300000,		2000,	0}, 	// 567
	{"",				3000,		500,	0},		// 568
	{"", 				0,			0,		0}, 	// 569
	{"",    			0,			0,		0}, 	// 570
	{"", 				3000,			100,		0}, 	// 571
	{"", 		 0,			0,		0}, 	// 572
	{"Mercedes-Benz G65 6x6", 		45000000,	20000,	0}, 	// 573
	{"", 			0,			0,		0},		// 574
	{" 20",				3000,		600,	0}, 	// 575
	{"-408",			125000,		600,	0}, 	// 576
	{"AT 400", 				0,			0,		0}, 	// 577
	{" ", 			0,			0,		0}, 	// 578
	{"Mercedes-Benz G65",	13750000,	48000,	0},		// 579
	{"",				3000,	15000,	0}, 	// 580
	{"Suzuki Hayabusa",				1000000,		700,	0}, 	// 581
	{" ",			0,			0,		0}, 	// 582
	{"Tug", 				0,			0,		0}, 	// 583
	{"", 			0,			0,		0}, 	// 584
	{"Mercedes-Benz S600",		4500000,		2800,	0}, 	// 585
	{"Harley Fat Boy'",	2050000,		400,	0}, 	// 586
	{"Audi Quattro",			6000000,	24000,	0}, 	// 587
	{" ", 			0,			0,		0}, 	// 588
	{"Volkswagen Golf",		1200000,	12400,	0}, 	// 589
	{"", 				0,			0,		0}, 	// 590
	{"", 				525000,			0,		0}, 	// 591
	{"Androm", 	     		0,			0,		0}, 	// 592
	{"", 				0,			0,		0}, 	// 593
	{"RCcam", 				0,			0,		0}, 	// 594
	{"LAUNCH", 				250000000,			0,		0}, 	// 595
	{" ", 			0,			0,		0}, 	// 596
	{" ", 			0,			0,		0}, 	// 597
	{" ", 			0,			0,		0}, 	// 598
	{"", 			0,			0,		0}, 	// 599
	{" 2717",			125000,		800,	0}, 	// 600
	{"-80", 				0,			0,		0}, 	// 601
	{"Jaguar F-Type",			10300000,	34000,	0}, 	// 602
	{"Dodge Charger", 		3000,	17000,	0}, 	// 603
	{"Porsche Panamera Turbo", 			21000000,			0,		0}, 	// 604
	{"Lamborghini Huracan", 			35000000,			0,		0},		// 605
	{"", 			0,			0,		0},		// 606
	{"", 			0,			0,		0},		// 607
	{"", 			0,			0,		0},		// 608
	{"", 				0,			0,		0},		// 609
	{"", 				0,			0,		0},		// 610
	{"", 		0,			0,		0},		// 611
	{"BMW M5 E60", 		     	5000000,			10000,		0}, // 612
	{"Niva Urban", 				1200000,			10000,		0}, // 613
	{"BMW X6M E71", 	         	6500000,			10000,		0}, // 614
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"Volkswagen Beetle", 				1500000,			10000,		0}, // 699
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"Audi Q7", 		   	14250000,			5700,		0}, // 793
	{"BMW M2", 				15750000,			6300,		0}, // 794
	{"Mercedes-Benz 4x4*2", 30000000,			12000,		0}, // 795
	{"Mercedes-Benz G-Class W464",            	25000000,			10000,		0}, // 796
	{"Ford Mustang GT 5.0",             	13750000,			5000,		0}, // 797
	{"Mercedes-Benz W221 S63", 	            8000000,			10000,		0}, // 798
	{" 31105 ", 				875000,			10000,		0}, // 799
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 		     	10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"BMW X5 F15", 		    9000000,			10000,		0}, // 907
	{"BMW X5M E70", 		1700000,			10000,		0}, // 908
	{"Volvo XC 90", 		680000,		    	10000,		0}, // 909
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"Mercedes-Maybach Pullman",            	62500000,			10000,		0}, // 965
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"Lamborghini Urus",    30000000,			10000,		0}, // 999
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 	            5000000,			5000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"Mercedes-Benz GLE63 Coupe",         17000000,			10000,		0}, // 1326
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"",            	7000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"", 				10000000,			10000,		0},
	{"Toyota Chaser", 		2800000,			10000,		0}, // 15065
	{"Volkswagen Touareg", 	5000000,			10000,		0}, // 15066
	{"BMW E38 740", 		3500000,			10000,		0}, // 15067
	{"Toyota Mark II", 		2500000,			10000,		0}, // 15068
	{"Toyota Camry v50",    4200000,			10000,		0}, // 15069
	{" 452 ", 	475000,			    10000,		0}, // 15070
	{"Lexus LX570", 		20000000,			10000,		0}, // 15071
	{"Lexus IS200", 		3000000,			10000,		0}, // 15072
	{"BMW 540 F02", 		7250000,			10000,		0}, // 15073
	{" 2114", 			487500,		     	10000,		0}, // 15074
	{"Jeep Grand Cherokee Trackhawk", 	26000000,			5000,		0}, // 15075
	{"Cadillac Escalade", 	31000000,			10000,		0}, // 15076
	{"Honda Accord", 		2500000,		    	10000,		0}, // 15077
	{" 2110", 			400000,			    10000,		0}, // 15078
	{" 2104", 			212500,	     		10000,		0}, // 15079
	{" 2105", 				262500,			10000,		0}, // 15080
	{"Volkswagen Scirocco", 				2800000,			10000,		0}, // 15081
	{"MERCEDES-BENZ 560", 	31000000,			10000,		0}, // 15082
	{" 66 ", 				1200000,			10000,		0}, // 15083
	{"Alfa Romeo 155", 				750000,			10000,		0}, // 15084
	{"Bugatti Chiron", 			125000000,			40000,		0}, // 15085
	{"LEXUS IS F", 			4500000,			10000,		0}, // 15086
	{"Mazda 3 MPS", 				3000000,			10000,		0}, // 15087
	{"Mazda MX-5", 				2500000,			10000,		0}, // 15088
	{"Audi RS7", 				13250000,			10000,		0}, // 15089
	{"Nissan Silvia S15", 				4000000,			10000,		0}, // 15090
	{"Mercedes-Benz 300SL", 				3000,			10000,		0}, // 15091
	{"Volvo XC90", 				7800000,			10000,		0}, // 15092
	{"Mercedes-Benz W124 E", 	55555555,			10000,		0}, // 15093
	{"BMW X6M F16", 				10500000,			10000,		0}, // 15094
	{"Mercedes Benz Actros", 				7500000,			10000,		0}, // 15095
	{"Volvo FM112", 				6300000,			10000,		0}, // 15096
	{"", 				10000000,			10000,		0}, // 15097
	{" 54115", 				4000000,			10000,		0}, // 15098
	{"", 				6500000,			10000,		0}, // 15099
	{"Scania R700", 				10000000,			10000,		0}, // 15100
	{" 130", 				1800000,			10000,		0}, // 15101
	{"MAN TGS", 				6500000,			10000,		0}, // 15102
	{" 131", 				2400000,			10000,		0}, // 15103
	{"Tesla Cybertruck", 				3000,			10000,		0}, // 15104
	{"BMW M1", 				55000000,			10000,		0}, // 15105
	{"BMW Z4 M40 2019", 				20000000,			10000,		0}, // 15106
	{"BMW M5 F90", 			32000000,			10000,		0}, // 15107
	{"Maserati Levante 2017", 	15000000,			10000,		0}, // 15108
	{"BMW I8 Roadster", 	28000000,			10000,		0}, // 15109
	{"Tesla Cybertruck Coca-Cola", 				3000,			10000,		0}, // 15110
	{" Tesla Cybertruck", 				3000,			10000,		0}, // 15111
	{"  Tesla Cybertruck", 				10000000,			10000,		0}, // 15112
	{"Chevrolet Corvette Z", 				20000000,			10000,		0}, // 15113
	{"Mercedes Benz GT63S",      32000000,			10000,		0}, // 15114
	{"Jeep Grand Cherokee",   2000000,		    	10000,		0}, // 15115
	{"McLaren P1", 			50000000,			10000,		0}, // 15116
	{" ", 				3000,			10000,		0}, // 15117
	{"Toyota Prado 2016", 	7500000,			10000,		0}, // 15118
	{" ", 				1750000,			10000,		0}, // 15119
	{"Mercedes Benz E63", 	10000000,			10000,		0}, // 15120
	{"Lada Vesta", 				2200000,			10000,		0}, // 15121
	{" ", 				3000,			10000,		0}, // 15122
	{" ", 				0,			10000,		0}, // 15123
	{" 3102", 				150000,			10000,		0}, // 15124
	{"Mitsubishi Lancer X", 2000000,		    	10000,		0}, // 15125
	{"Tesla Model X", 			18000000,			10000,		0}, // 15126
	{"BMW 1000R", 				5500000,			10000,		0}, // 15127
	{"Toyota Camry 40", 	2100000,		     	10000,		0}, // 15128
	{"KTM", 				4000000,			10000,		0}, // 15129
	{"CrossBike", 				 2000000,			10000,		0}, // 15130
	{"Subaru Impreza WRX", 	2500000,			10000,		0}, // 15131
	{"DUCATI Diavel", 				5000000,			10000,		0}, // 15132
	{"-5", 				150000,			10000,		0}, // 15133
	{"Kawasaki Ninja H2R", 				8750000,			10000,		0}, // 15134
	{"Quad", 				1250000,			10000,		0}, // 15135
	{"Suzuki Hayabusa", 				5000000,			10000,		0}, // 15136
	{"Fenyr SuperSport", 	115000000,			10000,		0}, // 15137
	{"", 				0,			10000,		0}, // 15138
	{"Harley-Davidson RSR-", 				7500000,			10000,		0}, // 15139
	{"Mercedes C63 204", 	8000000,			10000,		0}, // 15140
	{"Mercedes Benz CLS63",      8700000,			10000,		0}, // 15141
	{"Mercedes Benz E63 20", 				13000000,			10000,		0}, // 15142
	{" ", 				0,			10000,		0}, // 15143
	{"Audi S3", 			5200000,		    2100,		0}, // 15144
	{" 21099", 				225000,			10000,		0}, // 15145
	{"Rolls Royce CULLINAN", 				87000000,			10000,		0}, // 15146
	{"Mercedes Benz X", 				6000000,			10000,		0}, // 15147
	{"Range Rover Velar", 				15000000,			10000,		0}, // 15148
	{"Audi RS6 C5", 		3750000,			10000,		0}, // 15149
	{"LADA 2112 ", 				400000,			10000,		0}, // 15150
	{"LADA 2112", 				425000,			10000,		0}, // 15151
	{"Volvo v40", 			4500000,			10000,		0}, // 15152
	{"BMW X7", 				30000000,			10000,		0}, // 15153
	{"",                 0,            10000,        0}, // 15154
	{"Mercedes W123 Coupe AMG",                 3000,            10000,        0}, // 15155
	{"Bentley Turbo R",                 3000,            10000,        0}, // 15156
	{"oyota Camry V70",                 4000000,            10000,        0},
	{"M5 F90 R",            13000000,            10000,        0},
	{"Acura NSX",           15000000,            10000,        0},
	{"MB SLR",              7000000,            10000,        0},
	{"BMW 850 CSI",         10000000,            10000,        0},
	{"Toyota Mark 2 New",   3000000,            10000,        0},
	{"Honda",               6000000,            10000,        0},
	{"BMW M8 F92",          15000000,            10000,        0}, //15164
   	{"BMW M4 G82",          9000000,            10000,        0}, //15165
   	{"MB S63",              12500000,            10000,        0}, //15166
   	{"MB S500",             10000000,            10000,        0}, //15167
   	{"BMW M3 E36",          13500000,            10000,        0}, //15168
	{"Chevrolet Corvette C8", 	64500000,			10000,		0}, //15169
	{"Ferrari F40", 		35000000,			10000,		0}, //15170
	{"Honda Civic Type-R", 	27500000,			10000,		0}, //15171
	{"Lexus LFA", 			24000000,			10000,		0}, //15172
	{"Porsche 911 992", 	57500000,			10000,		0}, //15173
	{"Shelby Cobra",        95000000,            10000,      0}, //15174
	{"BMW M5 F90 CS",       55900000,            10000,      0}, //15175
	{"Mercedes-Benz SLS AMG",       49900000,            10000,      0}, //15176
    {"HUMMER H1",       75900000,            10000,      0}, //15177
    {"Mercedes-Benz SL65 AMG",       21700000,            10000,      0}, //15178
    {"Bentley 8-Liter",           65000000,            10000,    0}, //15179
    {"BMW M3 E46",           9000000,            10000,    0}, //15180
    {"BMW M1 E82",           11000000,            10000,    0}, //15181
    {"Ferrari Exclusive",           29000000,            10000,    0}, //15182
    {"Volkswagen Golf 5 GTI",           8500000,            10000,    0}, //15183
    {"Toyota Hachiroku AE86",           6000000,            10000,    0}, //15184
    {"Skoda Octavia VRS",           8500000,            10000,    0}, //15185
    {"Skoda Octavia VRS DPS",           3000,            10000,    0}, //15186
    {"Ferrari 599XX",           27500000,            10000,    0}, //15187
    {"BMW X6M F96",           32500000,            10000,    0} //15188

};
// ------------------------------------

stock SetVehicleDataAll(vehicleid, modelid, Float:x, Float:y, Float:z, Float:angle, color1, color2, respawn_delay, addsiren=0, action_type, action_id)
{
	if(IsValidVehicleID(vehicleid))
	{
		SetVehicleData(vehicleid, V_MODELID, modelid);

		SetVehicleData(vehicleid, V_SPAWN_X, 		x);
		SetVehicleData(vehicleid, V_SPAWN_Y, 		y);
		SetVehicleData(vehicleid, V_SPAWN_Z, 		z);
		SetVehicleData(vehicleid, V_SPAWN_ANGLE, 	angle);

		SetVehicleData(vehicleid, V_COLOR_1, 	color1);
		SetVehicleData(vehicleid, V_COLOR_2, 	color2);

		SetVehicleData(vehicleid, V_RESPAWN_DELAY, 	respawn_delay);
		SetVehicleData(vehicleid, V_ADDSIREN, 		addsiren);

		SetVehicleData(vehicleid, V_ACTION_TYPE, 	action_type);
		SetVehicleData(vehicleid, V_ACTION_ID, 		action_id);
		SetVehicleData(vehicleid, V_DRIVER_ID, 		INVALID_PLAYER_ID);

		SetVehicleData(vehicleid, V_FUEL, 40.0);
		SetVehicleData(vehicleid, V_MILEAGE, 0.0);
		SetVehicleData(vehicleid, V_LIMIT, true);

		SetVehicleData(vehicleid, V_HEALTH, 1000.0);

		SetVehicleParamsEx(vehicleid, IsABike(vehicleid) ? VEHICLE_PARAM_ON : VEHICLE_PARAM_OFF, VEHICLE_PARAM_OFF, VEHICLE_PARAM_OFF, VEHICLE_PARAM_OFF, VEHICLE_PARAM_OFF, VEHICLE_PARAM_OFF, VEHICLE_PARAM_OFF);
	}
}

stock n_veh_AddStaticVehicleEx(modelid, Float:x, Float:y, Float:z, Float:angle, color1, color2, respawn_delay, addsiren=0, action_type=VEHICLE_ACTION_TYPE_NONE, action_id=VEHICLE_ACTION_ID_NONE)
{
	static n_veh_vehicleid = INVALID_VEHICLE_ID;

	n_veh_vehicleid = AddStaticVehicleEx(modelid, x, y, z, angle, color1, color2, respawn_delay);
	SetVehicleDataAll(n_veh_vehicleid, modelid, x, y, z, angle, color1, color2, respawn_delay, addsiren, action_type, action_id);

	return n_veh_vehicleid;

	// The vehicle ID of the vehicle created (1 - MAX_VEHICLES).
	// INVALID_VEHICLE_ID (65535) if vehicle was not created (vehicle limit reached or invalid vehicle model ID passed).
}
#if defined _ALS_AddStaticVehicleEx
    #undef AddStaticVehicleEx
#else
    #define _ALS_AddStaticVehicleEx
#endif
#define AddStaticVehicleEx n_veh_AddStaticVehicleEx

stock n_veh_AddStaticVehicle(modelid, Float:x, Float:y, Float:z, Float:angle, color1, color2, action_type=VEHICLE_ACTION_TYPE_NONE, action_id=VEHICLE_ACTION_ID_NONE)
{
	static n_veh_vehicleid = INVALID_VEHICLE_ID;

	n_veh_vehicleid = AddStaticVehicle(modelid, x, y, z, angle, color1, color2);
	SetVehicleDataAll(n_veh_vehicleid, modelid, x, y, z, angle, color1, color2, 0, 0, action_type, action_id);

	return n_veh_vehicleid;

	// The vehicle ID of the vehicle created (1 - MAX_VEHICLES).
	// INVALID_VEHICLE_ID (65535) if vehicle was not created (vehicle limit reached or invalid vehicle model ID passed).
}
#if defined _ALS_AddStaticVehicle
    #undef AddStaticVehicle
#else
    #define _ALS_AddStaticVehicle
#endif
#define AddStaticVehicle n_veh_AddStaticVehicle

stock n_veh_CreateVehicle(modelid, Float:x, Float:y, Float:z, Float:angle, color1, color2, respawn_delay, addsiren=0, action_type=VEHICLE_ACTION_TYPE_NONE, action_id=VEHICLE_ACTION_ID_NONE)
{
	static n_veh_vehicleid = INVALID_VEHICLE_ID;

	n_veh_vehicleid = CreateVehicle(modelid, x, y, z, angle, color1, color2, respawn_delay);
	SetVehicleDataAll(n_veh_vehicleid, modelid, x, y, z, angle, color1, color2, respawn_delay, addsiren, action_type, action_id);

	return n_veh_vehicleid;

	// The vehicle ID of the vehicle created (1 - MAX_VEHICLES).
	// INVALID_VEHICLE_ID (65535) if vehicle was not created (vehicle limit reached or invalid vehicle model ID passed).
}
#if defined _ALS_CreateVehicle
    #undef CreateVehicle
#else
    #define _ALS_CreateVehicle
#endif
#define CreateVehicle n_veh_CreateVehicle

stock n_veh_DestroyVehicle(vehicleid)
{
	if(IsValidVehicleID(vehicleid))
	{
		ClearVehicleData(vehicleid);
		DestroyVehicleLabel(vehicleid);
	}
	return DestroyVehicle(vehicleid);
}
#if defined _ALS_DestroyVehicle
    #undef DestroyVehicle
#else
    #define _ALS_DestroyVehicle
#endif
#define DestroyVehicle n_veh_DestroyVehicle

public OnGameModeInit()
{
    for(new idx = 0; idx < MAX_VEHICLES; idx ++)
	{
		ClearVehicleData(idx);
	}

#if defined n_veh_OnGameModeInit
    n_veh_OnGameModeInit();
#endif
    return 1;
}
#if defined _ALS_OnGameModeInit
    #undef OnGameModeInit
#else
    #define _ALS_OnGameModeInit
#endif
#define OnGameModeInit n_veh_OnGameModeInit
#if defined n_veh_OnGameModeInit
forward n_veh_OnGameModeInit();
#endif

// ---------------------------------------------------
stock SetVehicleParamsInit(vehicleid)
{
	GetVehicleParamsEx
	(
		vehicleid,
		g_vehicle_params[vehicleid][V_ENGINE],
		g_vehicle_params[vehicleid][V_LIGHTS],
		g_vehicle_params[vehicleid][V_ALARM],
		g_vehicle_params[vehicleid][V_LOCK],
		g_vehicle_params[vehicleid][V_BONNET],
		g_vehicle_params[vehicleid][V_BOOT],
		g_vehicle_params[vehicleid][V_OBJECTIVE]
	);
}

stock GetVehicleParam(vehicleid, E_VEHICLE_PARAMS_STRUCT:paramid)
{
	SetVehicleParamsInit(vehicleid);
	return g_vehicle_params[vehicleid][paramid];
}

stock SetVehicleParam(vehicleid, E_VEHICLE_PARAMS_STRUCT:paramid, set_value)
{
	SetVehicleParamsInit(vehicleid);
	g_vehicle_params[vehicleid][paramid] = bool: set_value;

	SetVehicleParamsEx
	(
		vehicleid,
		g_vehicle_params[vehicleid][V_ENGINE],
		g_vehicle_params[vehicleid][V_LIGHTS],
		g_vehicle_params[vehicleid][V_ALARM],
		g_vehicle_params[vehicleid][V_LOCK],
		g_vehicle_params[vehicleid][V_BONNET],
		g_vehicle_params[vehicleid][V_BOOT],
		g_vehicle_params[vehicleid][V_OBJECTIVE]
	);
}

stock CreateVehicleLabel(vehicleid, text[], color, Float:x, Float:y, Float:z, Float:drawdistance, testlos = 0, worldid = -1, interiorid = -1, playerid = -1, Float:streamdistance = STREAMER_3D_TEXT_LABEL_SD)
{
	if(IsValidVehicle(vehicleid))
	{
		SetVehicleData(vehicleid, V_LABEL, CreateDynamic3DTextLabel(text, color, x, y, z, drawdistance, INVALID_PLAYER_ID, vehicleid, testlos, worldid, interiorid, playerid, streamdistance));
	}
	return 1;
}

stock UpdateVehicleLabel(vehicleid, color, text[])
{
	if(IsValidVehicleID(vehicleid))
	{
		if(IsValidDynamic3DTextLabel(GetVehicleData(vehicleid, V_LABEL)))
		{
			UpdateDynamic3DTextLabelText(GetVehicleData(vehicleid, V_LABEL), color, text);
		}
	}
	return 1;
}

stock DestroyVehicleLabel(vehicleid)
{
	if(IsValidVehicleID(vehicleid))
	{
		if(IsValidDynamic3DTextLabel(GetVehicleData(vehicleid, V_LABEL)))
		{
			DestroyDynamic3DTextLabel(GetVehicleData(vehicleid, V_LABEL));
			SetVehicleData(vehicleid, V_LABEL, Text3D: -1);
		}
	}
	return 1;
}
